Gecode::Int::Channel::Dom< View, Offset, shared > Class Template Reference
Other available functionality » Integer propagators

Domain consistent channel propagator. More...

`#include <channel.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::Int::Channel::Base< DomInfo< View, Offset >, Offset, PC_INT_DOM >
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, int n, DomInfo< View, Offset > *xy, Offset &ox, Offset &oy)
| Post propagator for channeling on xy.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| Dom (Space &home, Dom &p)
| Constructor for cloning p.
| Dom (Home home, int n, DomInfo< View, Offset > *xy, Offset &ox, Offset &oy)
| Constructor for posting.
Protected Member Functions inherited from Gecode::Int::Channel::Base< DomInfo< View, Offset >, Offset, PC_INT_DOM >
| Base (Space &home, Base< DomInfo< View, Offset >, Offset, pc > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

Distinct::DomCtrl< View > | dc
| Propagation controller for propagating distinct.
Protected Attributes inherited from Gecode::Int::Channel::Base< DomInfo< View, Offset >, Offset, PC_INT_DOM >
int | n
| Number of views (actually twice as many for both x and y).
int | n_na
| Total number of not assigned views (not known to be assigned).
Offset | ox
| Offset transformation for x variables.
Offset | oy
| Offset transformation for y variables.
DomInfo< View, Offset > * | xy
| View and information for both x and y.

## Detailed Description

template<class View, class Offset, bool shared>
class Gecode::Int::Channel::Dom< View, Offset, shared >

Domain consistent channel propagator.

If shared is true, the same views can be contained in both x and y.

Requires

#include <gecode/int/channel.hh>
channel.hh

Definition at line 134 of file channel.hh.

## Constructor & Destructor Documentation

## Dom() [1/2]

template<class View, class Offset, bool shared>

Gecode::Int::Channel::Dom< View, Offset, shared >::Dom | ( | Space & | home,
|  | Dom< View, Offset, shared > & | p )

protected

Constructor for cloning p.

## Dom() [2/2]

template<class View, class Offset, bool shared>

Gecode::Int::Channel::Dom< View, Offset, shared >::Dom | ( | Home | home,
|  | int | n,
|  | DomInfo< View, Offset > * | xy,
|  | Offset & | ox,
|  | Offset & | oy )

inline protected

Constructor for posting.

Definition at line 169 of file dom.hpp.

## Member Function Documentation

## copy()

template<class View, class Offset, bool shared>

Actor * Gecode::Int::Channel::Dom< View, Offset, shared >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 180 of file dom.hpp.

## cost()

template<class View, class Offset, bool shared>

PropCost Gecode::Int::Channel::Dom< View, Offset, shared >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

If in stage for naive value propagation, the cost is low quadratic. Otherwise it is high quadratic.

Reimplemented from Gecode::Int::Channel::Base< DomInfo< View, Offset >, Offset, PC_INT_DOM >.

Definition at line 186 of file dom.hpp.

## propagate()

template<class View, class Offset, bool shared>

ExecStatus Gecode::Int::Channel::Dom< View, Offset, shared >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 196 of file dom.hpp.

## post()

template<class View, class Offset, bool shared>

ExecStatus Gecode::Int::Channel::Dom< View, Offset, shared >::post | ( | Home | home,
|  | int | n,
|  | DomInfo< View, Offset > * | xy,
|  | Offset & | ox,
|  | Offset & | oy )

static

Post propagator for channeling on xy.

Definition at line 307 of file dom.hpp.

## Member Data Documentation

## dc

template<class View, class Offset, bool shared>

Distinct::DomCtrl<View> Gecode::Int::Channel::Dom< View, Offset, shared >::dc

protected

Propagation controller for propagating distinct.

Definition at line 142 of file channel.hh.

The documentation for this class was generated from the following files:

- gecode/int/channel.hh
- gecode/int/channel/dom.hpp